org.apache.hc.core5.http.impl.bootstrap

## Class AsyncRequester

- java.lang.Object
- - org.apache.hc.core5.http.impl.bootstrap.AsyncRequester

- All Implemented Interfaces:
    Closeable, AutoCloseable, ModalCloseable, ConnectionInitiator, IOReactor, IOReactorService
  Direct Known Subclasses:
    H2MultiplexingRequester, HttpAsyncRequester

      public class AsyncRequester
      extends Object
      implements IOReactorService

  Protocol agnostic client side I/O session initiator.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsyncRequester(IOEventHandlerFactory eventHandlerFactory, IOReactorConfig ioReactorConfig, Decorator<IOSession> ioSessionDecorator, Callback<Exception> exceptionCallback, IOSessionListener sessionListener, Callback<IOSession> sessionShutdownCallback, Resolver<HttpHost,InetSocketAddress> addressResolver)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `awaitShutdown(TimeValue waitTime)` Blocks for the given period of time in milliseconds awaiting the completion of the reactor shutdown.
    `void` | `close()`
    `void` | `close(CloseMode closeMode)` Shuts down the I/O reactor either gracefully or immediately.
    `Future<IOSession>` | `connect(NamedEndpoint remoteEndpoint, SocketAddress remoteAddress, SocketAddress localAddress, Timeout timeout, Object attachment, FutureCallback<IOSession> callback)` Requests a connection to a remote host.
    `IOReactorStatus` | `getStatus()` Returns the current status of the reactor.
    `void` | `initiateShutdown()` Initiates shutdown of the reactor without blocking.
    `Future<IOSession>` | `requestSession(HttpHost host, Timeout timeout, Object attachment, FutureCallback<IOSession> callback)`
    `void` | `start()` Starts I/O reactor.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AsyncRequester

          @Internal
          public AsyncRequester(IOEventHandlerFactory eventHandlerFactory,
                                 IOReactorConfig ioReactorConfig,
                                 Decorator<IOSession> ioSessionDecorator,
                                 Callback<Exception> exceptionCallback,
                                 IOSessionListener sessionListener,
                                 Callback<IOSession> sessionShutdownCallback,
                                 Resolver<HttpHost,InetSocketAddress> addressResolver)

  - ### Method Detail

    - #### requestSession

          public Future<IOSession> requestSession(HttpHost host,
                                         Timeout timeout,
                                         Object attachment,
                                         FutureCallback<IOSession> callback)

    - #### start

          public void start()

      Description copied from interface: `IOReactorService`
      Starts I/O reactor.
      Specified by:
        `start` in interface `IOReactorService`

    - #### getStatus

          public IOReactorStatus getStatus()

      Description copied from interface: `IOReactor`
      Returns the current status of the reactor.
      Specified by:
        `getStatus` in interface `IOReactor`
      Returns:
        reactor status.

    - #### initiateShutdown

          public void initiateShutdown()

      Description copied from interface: `IOReactor`
      Initiates shutdown of the reactor without blocking. The reactor is expected to terminate all active connections, to shut down itself and to release system resources it currently holds
      Specified by:
        `initiateShutdown` in interface `IOReactor`

    - #### awaitShutdown

          public void awaitShutdown(TimeValue waitTime)
                             throws InterruptedException

      Description copied from interface: `IOReactor`
      Blocks for the given period of time in milliseconds awaiting the completion of the reactor shutdown.
      Specified by:
        `awaitShutdown` in interface `IOReactor`
      Parameters:
        `waitTime` - wait time.
      Throws:
        `InterruptedException`

    - #### close

          public void close(CloseMode closeMode)

      Description copied from interface: `IOReactor`
      Shuts down the I/O reactor either gracefully or immediately. During graceful shutdown individual I/O sessions should be informed about imminent termination and be given a grace period to complete the ongoing I/O sessions. During immediate shutdown all ongoing I/O sessions get aborted immediately.
      Specified by:
        `close` in interface `ModalCloseable`
      Specified by:
        `close` in interface `IOReactor`
      Parameters:
        `closeMode` - How to close the I/O reactor.

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Throws:
        `IOException`

    - #### connect

          public final Future<IOSession> connect(NamedEndpoint remoteEndpoint,
                                  SocketAddress remoteAddress,
                                  SocketAddress localAddress,
                                  Timeout timeout,
                                  Object attachment,
                                  FutureCallback<IOSession> callback)

      Description copied from interface: `ConnectionInitiator`
      Requests a connection to a remote host.

      Opening a connection to a remote host usually tends to be a time consuming process and may take a while to complete. One can monitor and control the process of session initialization by means of the `Future` interface.

      There are several parameters one can use to exert a greater control over the process of session initialization:

      A non-null local socket address parameter can be used to bind the socket to a specific local address.

      An attachment object can added to the new session's context upon initialization. This object can be used to pass an initial processing state to the protocol handler.

      It is often desirable to be able to react to the completion of a session request asynchronously without having to wait for it, blocking the current thread of execution. One can optionally provide an implementation `FutureCallback` instance to get notified of events related to session requests, such as request completion, cancellation, failure or timeout.

      Specified by:
        `connect` in interface `ConnectionInitiator`
      Parameters:
        `remoteEndpoint` - name of the remote host.
        `remoteAddress` - remote socket address.
        `localAddress` - local socket address. Can be `null`, in which can the default local address and a random port will be used.
        `timeout` - connect timeout.
        `attachment` - the attachment object. Can be `null`.
        `callback` - interface. Can be `null`.
      Returns:
        session request object.

Copyright © 2005–2022 The Apache Software Foundation. All rights reserved.